#pragma rtGlobals=3		// Use modern global access method and strict wave access.


//	Appends a wave note to a wave on a new line or first line if 
//	there are no previous wavenotes

	Function Append_WaveNote( W1, S1 )
		Wave W1
		String S1
		Note W1, S1
	End
	
	--------------------------------------------------------------

//	Replaces existing wavenote(s) with new note

	Function Replace_WaveNote( W1, S1 )
		Wave W1
		String S1
		Note/K W1, S1
	End
	
	---------------------------------------------------------------
	
	Function Add_CsrA_WaveNote()
		SetDataFolder root:
			String/G G_WNote, G_Choice
			String WNote = G_WNote, Choice = G_Choice
			Prompt WNote, "Note To Add:"
			Prompt Choice, "Append or Replace", popup, "Append;Replace;"
			DoPrompt "Add_CsrA_WaveNote", WNote, Choice; AbortOnValue V_Flag, 0
			G_WNote = WNote; G_Choice = Choice
			Wave W1 = CsrWaveRef( A )
			If( StringMatch( Choice, "Append" ) )
				Append_WaveNote( W1, WNote )
			Else
				Replace_WaveNote( W1, WNote )
			EndIf	
	End

	---------------------------------------------------------------
	
	Function Add_CsrB_WaveNote()
		SetDataFolder root:
			String/G G_WNote, G_Choice
			String WNote = G_WNote, Choice = G_Choice
			Prompt WNote, "Note To Add:"
			Prompt Choice, "Append or Replace", popup, "Append;Replace;"
			DoPrompt "Add_CsrB_WaveNote", WNote, Choice; AbortOnValue V_Flag, 0
			G_WNote = WNote; G_Choice = Choice
			Wave W1 = CsrWaveRef( B )
			If( StringMatch( Choice, "Append" ) )
				Append_WaveNote( W1, WNote )
			Else
				Replace_WaveNote( W1, WNote )
			EndIf	
	End

	---------------------------------------------------------------

// Appends or replaces WaveNotes for all waves in specified folder
// To erase notes, use blank comment and Replace option
 
	Function Folder_WaveNotes( )
		SetDataFolder root:
			String/G G_WNote, G_Choice, G_Folder
			String Folder = G_Folder, Choice = G_Choice, WNote = G_WNote
			Prompt WNote, "Note To Add:"
			Prompt Folder, "Folder:", popup, "root:;" + SortList( FolderList("*") )
			Prompt Choice, "Append or Replace", popup, "Append;Replace;"
			DoPrompt "Folder_WaveNotes", WNote, Folder, Choice; AbortOnValue V_Flag, 0
			G_Folder = Folder, G_Choice = Choice, G_WNote = WNote
			Variable i = 0		
			String WList
		SetDataFolder $Folder	
			WList = WaveList("*",";","")
			If( ItemsInList( WList )  < 1 ) 
				ABORT "No Waves in data folder " + Folder
			EndIf
			Do
				WAVE Wv = $StringFromList( i, WList )
				If( !CmpStr( Choice, "Append" ) )
					Append_WaveNote( Wv, WNote )
				EndIf
				If( !CmpStr( Choice, "Replace" ) )
					Replace_WaveNote( Wv, WNote )
				EndIf
				i += 1
			While( i < ItemsInList( WList ) )	
		SetDataFolder root:
	End
 
	Function Folder_WaveNotes_F( WNote, Folder, Choice )
		String Folder, Choice, WNote
		SetDataFolder root:
			Variable i = 0		
			String WList
		SetDataFolder $Folder	
			WList = WaveList("*",";","")
			If( ItemsInList( WList ) < 1 ) 
				ABORT "No Waves in data folder " + Folder
			EndIf
			Do
				WAVE Wv = $StringFromList( i, WList )
				If( !CmpStr( Choice, "Append" ) )
					Append_WaveNote( Wv, WNote )
				EndIf
				If( !CmpStr( Choice, "Replace" ) )
					Replace_WaveNote( Wv, WNote )
				EndIf
				i += 1
			While( i < ItemsInList( WList ) )	
		SetDataFolder root:
	End
	
	---------------------------------------------------------------

// Appends or replaces WaveNotes for all waves in selected in the DataBrowser
// To erase notes, use blank comment and Replace option
 
	Function Selected_WaveNotes( )
		String/G G_WNote, G_Choice, G_Folder
		String Folder = G_Folder, Choice = G_Choice, WNote = G_WNote
		Prompt WNote, "Note To Add:"
		Prompt Choice, "Append or Replace", popup, "Append;Replace;"
		DoPrompt "Selected_WaveNotes", WNote, Choice; AbortOnValue V_Flag, 0
		G_Folder = Folder, G_Choice = Choice, G_WNote = WNote
		Variable i = 0		
		String WList
		WList = Browser_WaveList()
		If( ItemsInList( WList )  < 1 ) 
			ABORT "No Waves in Selection."
		EndIf
		Do
			WAVE Wv = $StringFromList( i, WList )
			If( !CmpStr( Choice, "Append" ) )
				Append_WaveNote( Wv, WNote )
			EndIf
			If( !CmpStr( Choice, "Replace" ) )
				Replace_WaveNote( Wv, WNote )
			EndIf
			i += 1
		While( i < ItemsInList( WList ) )	
	End
	
	---------------------------------------------------------------

	Function Print_CsrA_WaveNote()
		If (StrLen( Note( CsrWaveRef( A ) ) ) == 0 )
			Print CsrWave( A ), "Has No WaveNote"
		Else
			Print CsrWave( A ), "NOTE:"+Note( CsrWaveRef( A ) )
		EndIf
	End	
	
	---------------------------------------------------------------
	
	Function Print_CsrB_WaveNote()
		If (StrLen( Note( CsrWaveRef( B ) ) ) == 0 )
			Print CsrWave( B ), "Has No WaveNote"
		Else
			Print CsrWave( B ), "NOTE:"+Note( CsrWaveRef( B ) )
		EndIf
	End	
	

