﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.
	
	// This function changes the default axis named "DepthAxis" or "AgeAxis" for all open windows in an experiment to the same range
	
	Function AgeOrDepthAxisRange()
		SetDataFolder root:
			String/G G_XAxisName
			String XAxisName = G_XAxisName
			Variable/G G_V_Top, G_V_Bottom, G_Range_Incr
			Variable V_Top = G_V_Top
			Variable V_Bottom = G_V_Bottom, i, Range_Incr = G_Range_Incr
			String XAxisNameList = XAxisList( ), TempName, TempNames = ""
			For( i = 0; i < ItemsInList( XAxisNameList ); i += 1 ) //    this loop removes  "Axis" from the end of the axes names for the X axis list below
				TempName = StringFromList( i, XAxisNameList )
				TempName = TempName[ 0, StrLen( TempName ) - 5 ]
				TempNames = TempNames + TempName + ";"
			EndFor
 			XAxisNameList = TempNames		
			Prompt XAxisName, "XAxisName", popup, XAxisNameList
			Prompt V_Top, "Top Depth/Age of Range:"
			Prompt V_Bottom, "Bottom Depth/Age of Range:"
			Prompt Range_Incr, "Amount to shift range with next call to this function:"
			DoPrompt "AgeOrDepthAxisRange", XAxisName V_Top, V_Bottom, Range_Incr
			G_Range_Incr = Range_Incr; G_V_Top = V_Top; G_V_Bottom = V_Bottom; G_XAxisName = XAxisName; AbortOnValue V_Flag, 0
			String ListOfGraphs = WinList( "*", ";", "WIN:1" ), GraphName, Axis
			AgeOrDepthAxisRange_F( XAxisName, V_Top, V_Bottom, Range_Incr )
	End
	
---------------------------------------------------------------------------------------------	
	
	Function AgeOrDepthAxisRange_F( XAxisName, V_Top, V_Bottom, Range_Incr )
		Variable V_Top, V_Bottom, Range_Incr
		String XAxisName
		SetDataFolder root:
			Variable i
			String AxisName = XAxisName + "Axis" // Form the name of the Axis as either "DepthAxis" or "AgeAxis"
			String ListOfGraphs = WinList( "*", ";", "WIN:1" ) // Make a list of graphs
			String GraphName, AxisOrientation
			For( i = 0; i < ItemsInList( ListOfGraphs ); i += 1 ) // Loop through all of the graphs
				GraphName = StringFromList( i, ListOfGraphs )
				AxisOrientation = StringByKey( "AxType", AxisInfo( GraphName, AxisName ) ) //Axis will be either left, right, top, or bottom
				If( StringMatch( AxisOrientation, "left" ) || StringMatch( AxisOrientation, "right" ) ) // If the axis is vertical
					SetAxis/Z/W = $GraphName $AxisName  V_Bottom, V_Top // If the depth axis is vertical, then the depths are plotted in reverse to make the top of the axis the shallowest depth
				Else					
					SetAxis/Z/W = $GraphName $AxisName  V_Top, V_Bottom // Sets the axis range for horizontal axes
				EndIf
			EndFor
			V_Top += Range_Incr // Set up for next run by incrementing the top and bottom depths/ages
			V_Bottom += Range_Incr
			Print "AgeOrDepthAxisRange_F( \"" + XAxisName + "\", " + Num2Str( V_Top) + "," + Num2Str( V_Bottom ) + "," + Num2Str( Range_Incr ) + " )"		
			Variable/G G_V_Top = V_Top, G_V_Bottom = V_Bottom			
	End
	
-----------------------------------------------------------------------------------------------
