﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.

	Function CalculateAgeTicks(  )	
		SetDataFolder root:		
			String/G G_Site, G_Folder, G_AgeWave, G_DepthWave
			String Site = G_Site, Folder = G_Folder, AgeWave = G_AgeWave, DepthWave = G_DepthWave
			Variable/G G_AgeIncrement
			Variable AgeIncrement = G_AgeIncrement
			Prompt Site, "Site"
			Prompt AgeIncrement, "Age increments for ticks - Myr"
			Prompt Folder, "Folder containing age model", popup, "root:;" + SortList( FolderList("*") )
			DoPrompt "CalculateAgeTicks", Site, AgeIncrement, Folder
			G_Site = Site; G_Folder = Folder; 
			G_AgeIncrement = AgeIncrement
			AbortOnValue V_Flag, 0
		SetDataFolder $Folder
			Prompt AgeWave, "Age Wave", popup, SortList( WaveList( "*", ";", "" ), ";", 1 )
			Prompt DepthWave, "Depth Wave", popup, SortList( WaveList( "*", ";", "" ), ";", 1 )
			DoPrompt "CalculateAgeTicks", AgeWave, DepthWave
			G_AgeWave = AgeWave, G_DepthWave = DepthWave
			AbortOnValue V_Flag, 0
			Print "CalculateAgeTicks_F( \"" + Site + "\", \"" + Folder + "\", \"" + AgeWave + "\", \"" + DepthWave + "\", " + Num2Str( AgeIncrement ) + " )"	
			CalculateAgeTicks_F( Site, Folder, AgeWave, DepthWave, AgeIncrement )	
	End

	Function CalculateAgeTicks_F( Site, Folder, AgeWave, DepthWave, AgeIncrement )	
			String Site, Folder, AgeWave, DepthWave
			Variable AgeIncrement
		SetDataFolder root:		
		NewDataFolder/O Xtras
		SetDataFolder Folder
			WAVE AgeWv = $AgeWave, DepthWv = $DepthWave
			If( CheckAgeModel( AgeWv, DepthWv ) == 0 )
				SetDataFolder root:
				String Msg1 = "The age and depth waves must both increase monotonically."
				String Msg2 = "\r\rUse the AgeDepthFit function to create a smooth age model in an AgeDepthFit folder. "
				String Msg3 = "If the age-depth fit is recurved try a different order for the fit or manually edit the age model waves."
				ABORT Msg1 + Msg2 + Msg3
			EndIf
			KillWaves/Z AgeWvDif, DepthWvDif
		NewDataFolder/O/S root:Xtras:AgeTicks
			Make/O/N = ( ( Wavemax(AgeWv)/AgeIncrement ) + 1 ) TempAges, $Site + "_AgeTickDepths"
			Make/T/O/N = ( ( Wavemax(AgeWv)/AgeIncrement ) + 1 ) $Site + "_AgeTicks"
			WAVE TickDepths = $Site + "_AgeTickDepths"
			WAVE/T AgeTicks = $Site + "_AgeTicks"
			TempAges = x * AgeIncrement
			AgeTicks = Num2Str( TempAges )
			TickDepths = Interp( TempAges, AgeWv, DepthWv )
		SetDataFolder root:	
			KillWaves TempAges
	End		

