﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.



	Function CalculateCoreSedRates()
		SetDataFolder root:
			Variable i, j
			String AgeWaveStr, MCDWaveStr, SedRateWaveStr, PlottedSedRates, SmoothSedRateWaveStr
		SetDataFolder :U807_IsoTian
			String DataList = SortList( WaveList( "*AgeTarget", ";", "" ), ";", 16 )
			For( i = 0; i < ItemsInList( DataList ); i += 1 )
				AgeWaveStr = StringFromList( i, DataList )
				MCDWaveStr = ReplaceString( "_AgeTarget", AgeWaveStr, "_mcd" )
				WAVE AgeWave = $AgeWaveStr, MCDWave = $MCDWaveStr
				If( WaveExists( AgeWave ) && WaveExists( MCDWave ) )
					SedRateWaveStr = ReplaceString( "_AgeTarget", AgeWaveStr, "_SedRate" )
					Duplicate/O AgeWave $SedRateWaveStr
					Wave SedRateWave = $SedRateWaveStr
					SedRateWave = NaN
					For( j = 1; j < NumPnts( SedRateWave ); j += 1 )
						SedRateWave[ j ] = ( MCDWave[ j ] - MCDWave[ j - 1 ] ) / ( AgeWave[ j ] - AgeWave[ j - 1 ] )
					EndFor
					 	SmoothSedRateWaveStr = SedRateWaveStr + "_smth"
					 	Duplicate/O SedRateWave, $SmoothSedRateWaveStr
					 	WAVE SedRateWave_smth = $SmoothSedRateWaveStr
						Smooth 5, SedRateWave_smth
					PlottedSedRates = TraceNameList( "", ";", 1 )
					If( StrSearch( PlottedSedRates, SedRateWaveStr, 0, 2 ) < 0 )
					 	AppendToGraph/L = SedRateAxis SedRateWave vs AgeWave
					 	SetAxis SedRateAxis 0,*
					 	ModifyGraph axisEnab(SedRateAxis)={0.75,1}, freePos(SedRateAxis)=0
					 	ModifyGraph mode($SedRateWaveStr)=1,lsize($SedRateWaveStr)=5
					 	ModifyGraph useNegRGB($SedRateWaveStr)=1,rgb($SedRateWaveStr)=(32769,65535,32768)
					 	ModifyGraph negRGB($SedRateWaveStr)=(0,0,0)
					 	SmoothSedRateWaveStr = SedRateWaveStr + "_smth"
					 	Duplicate/O SedRateWave, $SmoothSedRateWaveStr
					 	WAVE SedRateWave_smth = $SmoothSedRateWaveStr
						Smooth 5, SedRateWave_smth
						AppendToGraph/L=SedRateAxis SedRateWave_smth vs AgeWave
						ModifyGraph lsize($SmoothSedRateWaveStr)=3
						ModifyGraph rgb($SmoothSedRateWaveStr)=(2,39321,1)					 	
					EndIf	
				EndIf
			EndFor
		SetDataFolder root:			
	End
