﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.
	
	Function CoreRecoveryPlot( )
		SetDataFolder root:
			Variable/G G_AxisTop, G_AxisBottom
			Variable AxisTop = G_AxisTop, AxisBottom = G_AxisBottom			
			String/G G_Hole, G_NewOrApp, G_CSForCCSF
			String Hole = G_Hole, NewOrApp = G_NewOrApp, CSForCCSF = G_CSForCCSF
			Variable i, j
			Prompt Hole, "Hole"
			Prompt NewOrApp, "New, Append, or Update?", popup, "Append;Update;New"
			Prompt AxisBottom, "Axis Portion Bottom (%)"
			Prompt AxisTop, "Axis Portion Top (%)"
			Prompt CSForCCSF, "CSF or CCSF?", popup, "CSF;CCSF"
			DoPrompt "CoreRecoveryPlot", Hole, NewOrApp, AxisBottom, AxisTop, CSForCCSF
			G_Hole = Hole; G_NewOrApp = NewOrApp; G_AxisBottom = AxisBottom; G_AxisTop = AxisTop; G_CSForCCSF = CSForCCSF
			AbortOnValue V_Flag, 0
			CoreRecoveryPlot_F( Hole, NewOrApp, AxisBottom, AxisTop, CSForCCSF )
			Print "CoreRecoveryPlot_F( \"" + Hole + "\", \"" + NewOrApp + "\", " + Num2Str( AxisBottom ) + ", " + Num2Str( AxisTop ) + ", \"" + CSForCCSF + "\" )"
	End

	Function CoreRecoveryPlot_F( Hole, NewOrApp, AxisBottom, AxisTop, CSForCCSF )
		Variable AxisTop, AxisBottom	
		String Hole, NewOrApp, CSForCCSF
		SetDataFolder root:
			Variable i, j
			If( StringMatch( CSForCCSF, "CCSF" ) ) // Checks to see that the matrix has CCSF values
				CheckMatrix4CCSF( Hole )
			EndIf
			WAVE Matrix = $Hole + "_Coring_Matrix"	
		NewDataFolder/O Xtras	
		NewDataFolder/O/S $":Xtras:RecoveryPlotXtras" + CSForCCSF	
			Make/O/N = ( DimSize( Matrix, 0 ) ) $Hole + "_TopCSF1"
			WAVE TopCSF1 = $Hole + "_TopCSF1"
			TopCSF1 = NaN
			Duplicate/O TopCSF1,  $Hole + "_TopCSF2", $Hole + "_MidCSF", $Hole + "_BottomCSF", $Hole + "_IntervalLength", $Hole + "_CoredLength", $Hole + "_CoredIntervalBottomCSF"
			WAVE TopCSF2 = $Hole + "_TopCSF2", MidCSF = $Hole + "_MidCSF", BottomCSF = $Hole + "_BottomCSF", IntervalLength = $Hole + "_IntervalLength", CoredLength = $Hole + "_CoredLength"
			WAVE TopCSF2 = $Hole + "_TopCSF2", MidCSF = $Hole + "_MidCSF", BottomCSF = $Hole + "_BottomCSF"
			WAVE IntervalLength = $Hole + "_IntervalLength", CoredLength = $Hole + "_CoredLength", CoredIntervalBottomCSF = $Hole + "_CoredIntervalBottomCSF"
			Duplicate/O TopCSF1 $Hole + "_RecoveryONEs", $Hole + "_RecoveryONEs1", $Hole + "_RecoveryONEs2", $Hole + "_RecoveryONEs3", $Hole + "_RecoveryHalfs", $Hole + "_CoreNumbers"
			WAVE RecoveryONEs = $Hole + "_RecoveryONEs", RecoveryONEs1 = $Hole + "_RecoveryONEs1", RecoveryONEs2 = $Hole + "_RecoveryONEs2"
			WAVE RecoveryONEs = $Hole + "_RecoveryONEs", RecoveryONEs1 = $Hole + "_RecoveryONEs1", RecoveryONEs2 = $Hole + "_RecoveryONEs2"
			WAVE RecoveryONEs3 = $Hole + "_RecoveryONEs3", RecoveryHalfs = $Hole + "_RecoveryHalfs", CoreNumbers = $Hole + "_CoreNumbers"
			TopCSF1 = Matrix[ p ][ 1 ][ 0 ]
			TopCSF2 = TopCSF1
			Rotate -1, TopCSF2
			CoredLength = TopCSF2 - TopCSF1
			CoredLength[ NumPnts( CoredLength ) -1 ] = CoredLength[ NumPnts( CoredLength ) -2 ]
			If( StringMatch( "CCSF", CSForCCSF ) )
				TopCSF1 = Matrix[ p ][ 1 ][ 2 ]
			Else
				TopCSF1 = Matrix[ p ][ 1 ][ 0 ]
			EndIf
			TopCSF2 = TopCSF1
			CoredIntervalBottomCSF = TopCSF1 + CoredLength
			CoreNumbers = p; CoreNumbers[ 0 ] = NaN
			RecoveryONEs = 1; RecoveryONEs1 = 1; RecoveryONEs2 = 1; RecoveryONEs3 = 1; RecoveryHalfs = .5
// This section caculates whats needed for the skeletal plot with core numbers.	
			WaveStats/Q TopCSF1
			If( V_NumNaNs > 1.5 )
				DoAlert 0, "There are cored intervals with no recovery. You must open the coring matrix and manually add depths to the tops of cored intervals in Column 1 of the top layer.\r\rIn older coring matrices you may need to delete blank lines from the bottom."
				Edit Matrix
				ABORT
			EndIf
			Rotate -1, TopCSF2
			Variable Points = NumPnts( IntervalLength )
			IntervalLength = TopCSF2 - TopCSF1
			IntervalLength[ Points - 1 ] = IntervalLength[ Points - 2 ] // Sets cored interval for bottom core to the same as the core immediately above
			TopCSF2[ Points - 1 ] = TopCSF1[ Points - 1 ] + IntervalLength[ Points -1 ]
			MidCSF = TopCSF1 + ( CoredLength / 2 )
// This starts the black bar recovery column			
			Duplicate/O TopCSF1 TopSectionLengths
			TopSectionLengths = Matrix[ p ][ 1 ][ 1 ]
			Make/O/N = ( DimSize( Matrix, 1 ) ) SectionCSFs
			SectionCSFs = NaN
			Duplicate/O SectionCSFs SectionLengths
			For( i = 1; i < Points; i += 1 ) // This loop goes core by core calculating the bottom depth
			If( StringMatch( "CCSF", CSForCCSF ) )
				SectionCSFs = Matrix[ i ][ p ][ 2 ]
			Else
				SectionCSFs = Matrix[ i ][ p ][ 0 ]
			EndIf
				SectionLengths = Matrix[ i ][ p ][ 1 ]
				WaveStats/Q SectionCSFs
				BottomCSF[ i ] = SectionCSFs[ V_MaxLoc ] + SectionLengths[ V_MaxLoc ]
				EndFor	
			BottomCSF = BottomCSF < TopCSF2 ? BottomCSF[ p ] : TopCSF2[ p ] // This takes care of > 100% recovery.
			BottomCSF *= TopSectionLengths/TopSectionLengths // This resets BottomCSF for non-recovery to NaN.
			Make/O/N = ( 3 * Points ) $Hole + "_BlackBarPlot", $Hole + "_BlackBarOnes"
			WAVE BlackBarPlot = $Hole + "_BlackBarPlot", BlackBarOnes = $Hole + "_BlackBarOnes"
			BlackBarPlot = NaN; BlackBarOnes = 1
			j = 1
			For( i = 1; j < Points; i += 3 )
				BlackBarPlot[ i ] = TopCSF1[ j ]
				BlackBarPlot[ i + 1 ] = BottomCSF[ j ]
				BlackBarPlot[ i + 2 ] = NaN
				j += 1
			EndFor	
			Make/O/N = 2 $Hole + "_DepthLine", $Hole + "_DepthLineZeros"
			WAVE DepthLine = $Hole + "_DepthLine", DepthLineZeros = $Hole + "_DepthLineZeros"  
			DepthLine[ 1 ] = WaveMax( TopCSF2 ) // Depthline is for plotting a line from the top to the bottom of the Hole.			
			If( DimSize( Matrix, 0 ) < 3 ) // This is a special case where there is only 1 core.
				WaveStats/Q SectionCSFs
				BlackBarPlot = { V_Min, V_Max + SectionLengths[ V_MaxLoc ] }
				MidCSF[ 1 ] = ( ( BlackBarPlot[ 1 ] - BlackBarPlot[ 0 ] ) / 2 ) + BlackBarPlot[ 0 ]
				DepthLine = BlackBarPlot
				TopCSF2 = BlackBarPlot				
			EndIf			
			If( !StringMatch( NewOrApp, "Update" ) )
				BarPlot( Hole, NewOrApp, AxisBottom, AxisTop, CSForCCSF )
			EndIf
			KillWaves/Z SectionCSFs, SectionLengths, $Hole + "IntervalLength", TopSectionLengths
			KillWaves/Z BottomCSF, CoredLength, IntervalLength, RecoveryONEs1, TopCSF1
		SetDataFolder root:
	End
	
	Function BarPlot( Hole, NewOrApp, AxisBottom, AxisTop, CSForCCSF ) : Graph
		Variable AxisBottom, AxisTop
		String Hole, NewOrApp, CSForCCSF
		AxisBottom /= 100; AxisTop /= 100
		Variable AxisHalf = ( AxisTop - AxisBottom ) / 2
		SetDataFolder $"root:Xtras:RecoveryPlotXtras" + CSForCCSF
			If( StringMatch( "New", NewOrApp ) )
				Display /W=(570,169,2201,323)
			EndIf
			WAVE RecoveryONEs = $Hole + "_RecoveryONEs", RecoveryONEs2 = $Hole + "_RecoveryONEs2", RecoveryONEs3 = $Hole + "_RecoveryONEs3", RecoveryHalfs = $Hole + "_RecoveryHalfs"
			WAVE CoreNumbers = $Hole + "_CoreNumbers", BlackBarOnes = $Hole + "_BlackBarOnes", CoredIntervalBottomCSF = $Hole + "_CoredIntervalBottomCSF"
			WAVE TopCSF2 = $Hole + "_TopCSF2", MidCSF = $Hole + "_MidCSF", BlackBarPlot = $Hole + "_BlackBarPlot"
			WAVE DepthLine = $Hole + "_DepthLine", DepthLineZeros = $Hole + "_DepthLineZeros"  
			AppendToGraph/B = $"DepthAxis"/L = $Hole + "NumberedCores" RecoveryONEs vs TopCSF2
			AppendToGraph/B = $"DepthAxis"/L = $Hole + "NumberedCores" DepthLineZeros Vs DepthLine
			SetAxis $Hole + "NumberedCores" 0,1
			ModifyGraph mode($Hole + "_RecoveryONEs")=1
			AppendToGraph/B = $"DepthAxis"/L = $Hole + "NumberedCores" RecoveryHalfs vs MidCSF
			ModifyGraph mode($Hole + "_RecoveryHalfs")=3, msize($Hole + "_RecoveryHalfs")=4
			ModifyGraph textMarker($Hole + "_RecoveryHalfs")={$Hole + "_CoreNumbers","default",1,90,5,0.00,0.00}
			AppendToGraph/B = $"DepthAxis"/L = $Hole + "NumberedCores" RecoveryONEs2 vs TopCSF2
			ModifyGraph mode($Hole + "_RecoveryONEs2")=7
			ModifyGraph axisEnab($Hole + "NumberedCores")={ AxisBottom, AxisBottom + AxisHalf }
			AppendToGraph/B = $"DepthAxis"/L = $Hole + "Recovery" BlackBarONEs vs BlackBarPlot
			ModifyGraph axisEnab($Hole + "Recovery")={ AxisTop - AxisHalf, AxisTop }
			AppendToGraph/B = $"DepthAxis"/L = $Hole + "Recovery" RecoveryOnes vs DepthLine
			ModifyGraph mode($Hole + "_RecoveryONEs#1")=1
			AppendToGraph/B = $"DepthAxis"/L = $Hole + "Recovery" RecoveryOnes vs DepthLine
			SetAxis $Hole + "Recovery" 0,1
			AppendToGraph/B = $"DepthAxis"/L=$Hole + "NumberedCores" RecoveryONEs3 vs CoredIntervalBottomCSF
			ModifyGraph mode($Hole + "_RecoveryONEs3")=1
			ModifyGraph mode($Hole + "_BlackBarONEs")=7
			ModifyGraph hbFill($Hole + "_BlackBarONEs")=2
			ModifyGraph mirror($"DepthAxis")=2
			ModifyGraph tick($Hole + "NumberedCores")=3,tick($Hole + "Recovery")=3,noLabel($Hole + "NumberedCores")=1,noLabel($Hole + "Recovery")=1
			ModifyGraph rgb=(0,0,0),fStyle=0,freePos=0,standoff($"DepthAxis")=0
			ModifyGraph nticks($"DepthAxis")=10,minor($"DepthAxis")=1,fStyle($"DepthAxis")=1,fSize($"DepthAxis")=12
			SetAxis $"DepthAxis" 0,*
			Label $Hole + "NumberedCores" "\\f01\\Z12" + Hole
			ModifyGraph lblPos=20
	End

