﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.

	Function Data_MultiPlot( )
		SetDataFolder root:
			String/G G_HoleList, G_Technique, G_Data, G_Scale, G_New_or_App, G_SpliceYorN, G_SingleAxisYorN, G_ScaleName, G_XAxisName
			String HoleList = G_HoleList, Technique = G_Technique, Data = G_Data, Scale = G_Scale, XAxisName = G_XAxisName
			String SingleAxisYorN = G_SingleAxisYorN, New_or_App = G_New_or_App, SpliceYorN = G_SpliceYorN
			Prompt HoleList, "List of Holes to plot, separated by semicolons with no blank spaces (U844A;U844B;...)"
			Prompt Technique, "Technique"
			Prompt Data, "Data"
			Prompt Scale, "Depth/Age Type ( CSF, mbsf, CCSFA, etc )"
			Prompt XAxisName, "X Axis Name?", popup, "Depth;Age;OtherX"
			Prompt SpliceYorN, "Leave room for adding spliced data?", popup, "Y;N"
			Prompt SingleAxisYorN, "Single Axis or Side-By-Side Plotting?", popup, "MultiAxis;SingleAxis"
			Prompt New_or_App, "New or Append:", popup, "New;Append"
			DoPrompt "Data_MultiPlot", HoleList, Technique, Data, Scale, XAxisName, New_or_App, SpliceYorN, SingleAxisYorN
			G_HoleList = HoleList; G_Technique = Technique; G_Scale = Scale; G_XAxisName = XAxisName
			G_SingleAxisYorN = SingleAxisYorN; G_New_or_App = New_or_App; G_SpliceYorN = SpliceYorN
			AbortOnValue V_Flag, 0
			Data_MultiPlot_F( HoleList, Technique, Data, Scale, XAxisName, New_or_App, SpliceYorN, SingleAxisYorN )
			Printf "Data_MultiPlot_F( \"" + HoleList + "\", \"" + Technique + "\", \"" + Data + "\", \"" + Scale + "\", \"" + XAxisName + "\", \"" + New_or_App + "\", \"" + SpliceYorN + "\", \"" + SingleAxisYorN + "\" )\r"
	End
	
	Function Data_MultiPlot_F( HoleList, Technique, Data, Scale, XAxisName, New_or_App, SpliceYorN, SingleAxisYorN )
			String HoleList, Technique, Data, Scale, XAxisName, New_or_App, SpliceYorN, SingleAxisYorN
			CheckList4Semicolons( HoleList ) // Checks to make sure that the list of holes is semicolon separated
		SetDataFolder root:
			String/G G_NewAxisName//, G_NewAxisPosition
			String NewAxisName = G_NewAxisName//, NewAxisPosition = G_NewAxisPosition
			If( StringMatch( XAxisName, "OtherX" ) )
				Prompt NewAxisName, "New Axis Name:"
				DoPrompt "Append_Data_F", NewAxisName
				G_NewAxisName = NewAxisName//, G_NewAxisPosition = NewAxisPosition
				AbortOnValue V_Flag, 0
				XAxisName = NewAxisName
			Endif
			If( StringMatch( SingleAxisYorN, "MultiAxis" ) ) // This loop plots the data on separate Y axes
					SetDataFolder root:					
						Variable i, HoleCount, DataWidth
						String Hole, Site
						HoleCount = ItemsInList( HoleList ) // How many data sets?
						If( Stringmatch( SpliceYorN, "Y" ) ) // Divides the width along the graph Y axis for each data set, add 1 if room for the splice is requested
							DataWidth = ( 100 / ( HoleCount + 1 ) )
						Else
							DataWidth = ( 100 / HoleCount )
						EndIf
						If( StringMatch( "New", New_or_App ) ) // Opens blank graph if this is a new plot
							Display/W=(576,67,1557,526)
						EndIf
						For( i = 0; i < HoleCount; i += 1 ) // This loop works through the hole list and appends the data
							Hole = StringFromList( i, HoleList )
							Site = RemoveEnding( Hole )
							WAVE/Z DataWave = $"root:" + Site + "_" + Technique + ":" + Hole + "_" + Technique + "_" + Data // Sets wave reference for data wave
							If( WaveExists( DataWave ) )
								AppendData_F( StringFromList( i, HoleList ), Technique, Data, Scale, XAxisName, "B", DataWidth * i , ( DataWidth * (i + 1) ), "R" )
							Else
								Print "\rI can't find " + Hole + "_" + Technique + "_" + Data + " in DataFolder " +  Site + "_" + Technique + "\r\r" // Error message if data wave is missing
							EndIf
						EndFor
						String/G G_New_or_App = New_or_App
						ModifyGraph nticks( $XAxisName + "Axis" )=10 ,minor( $XAxisName + "Axis" )=1, mirror( $XAxisName + "Axis" )=2 // Plot formatting
						ShowInfo // Add cursors
					SetDataFolder root:
			Else
				Data_SameAxisPlot_F( HoleList, Technique, Data, Scale, XAxisName, New_or_App, SpliceYorN ) // For single axis plots. See below
			EndIf
	End	

	Function Data_SameAxisPlot_F( HoleList, Technique, Data, Scale, XAxisName, New_or_App, SpliceYorN )
			String HoleList, Technique, Data, Scale, New_or_App, SpliceYorN, XAxisName
			CheckList4Semicolons( HoleList ) // Checks to make sure that the list of holes is semicolon separated
		SetDataFolder root:
			Variable i, HoleCount, DataWidth
			String Hole, Site
			HoleCount = ItemsInList( HoleList ) // How many data sets?
			If( StringMatch( "New", New_or_App ) ) // Opens blank graph if this is a new plot
				Display/W=(576,67,1557,526)
			EndIf
			For( i = 0; i < HoleCount; i += 1 )
				Hole = StringFromList( i, HoleList )
				Site = RemoveEnding( Hole )
		SetDataFolder $Site + "_" + Technique // Make the data folder the active folder
				WAVE/Z DataWave = $Hole + "_" + Technique + "_" + Data // Set wave reference for the data wave
				If( WaveExists( DataWave ) )
					AppendToGraph/B = $XAxisName + "Axis" /R = $Data $StringFromList( i, HoleList ) + "_" + Technique + "_" + Data  vs $Hole + "_" + Technique + "_" + Scale // Appends the data to the plot
				Else
					Print "\rI can't find " + Hole + "_" + Technique + "_" + Data + " in DataFolder " +  Site + "_" + Technique + "\r\r" // Error message if data wave is missing
				EndIf
		SetDataFolder root:
			EndFor
			String/G G_New_or_App = New_or_App
			ModifyGraph nticks($XAxisName + "Axis")=10,minor($XAxisName + "Axis")=1, mirror=2 // Formatting
			ModifyGraph freePos=0
			Label $Data "\\Z12\\f01" + Data
			ModifyGraph lblPosMode=2,lblMargin=5
			ShowInfo // Add cursors
			If( StringMatch( SpliceYorN, "Y" ) ) // If the user wants room for spliced data the single Y axis for the requested data is set to 0-75%
				ModifyGraph axisEnab($Data)={0,0.75}
			EndIf
		SetDataFolder root:
	End	



----------------------------------------------------------------------------------------------------------------


//	Function Data_MultiPlot( )
		SetDataFolder root:
			String/G G_HoleList, G_Technique, G_Data, G_Xaxis, G_New_or_App, G_SpliceYorN, G_SingleAxisYorN
			String HoleList = G_HoleList, Technique = G_Technique, Data = G_Data, Xaxis = G_Xaxis
			String SingleAxisYorN = G_SingleAxisYorN, New_or_App = G_New_or_App, SpliceYorN = G_SpliceYorN
			Prompt HoleList, "List of Holes to plot, separated by semicolons with no blank spaces (U844A;U844B;...)"
			Prompt Technique, "Technique"
			Prompt Data, "Data"
			Prompt Xaxis, "Depth/Age Type ( CSF, mbsf, CCSFA, etc )"
			Prompt SpliceYorN, "Leave room for adding spliced data?", popup, "Y;N"
			Prompt SingleAxisYorN, "Single Axis or Side-By-Side Plotting?", popup, "MultiAxis;SingleAxis"
			Prompt New_or_App, "New or Append:", popup, "New;Append"
			DoPrompt "Data_MultiPlot", HoleList, Technique, Data, Xaxis, New_or_App, SpliceYorN, SingleAxisYorN
			G_HoleList = HoleList; G_Technique = Technique; G_Xaxis = Xaxis
			G_SingleAxisYorN = SingleAxisYorN; G_New_or_App = New_or_App; G_SpliceYorN = SpliceYorN
			AbortOnValue V_Flag, 0
			Data_MultiPlot_F( HoleList, Technique, Data, Xaxis, New_or_App, SpliceYorN, SingleAxisYorN )
			Printf "Data_MultiPlot_F( \"" + HoleList + "\", \"" + Technique + "\", \"" + Data + "\", \"" + Xaxis + "\", \"" + New_or_App + "\", \"" + SpliceYorN + "\", \"" + SingleAxisYorN + "\" )\r"
	End
	
//	Function Data_MultiPlot_F( HoleList, Technique, Data, Xaxis, New_or_App, SpliceYorN, SingleAxisYorN )
			String HoleList, Technique, Data, Xaxis, New_or_App, SpliceYorN, SingleAxisYorN
			CheckList4Semicolons( HoleList ) // Checks to make sure that the list of holes is semicolon separated
			If( StringMatch( SingleAxisYorN, "MultiAxis" ) ) // This loop plots the data on separate Y axes
					SetDataFolder root:
						Variable i, HoleCount, DataWidth
						String Hole, Site
						HoleCount = ItemsInList( HoleList ) // How many data sets?
						If( Stringmatch( SpliceYorN, "Y" ) ) // Divides the width along the graph Y axis for each data set, add 1 if room for the splice is requested
							DataWidth = ( 100 / ( HoleCount + 1 ) )
						Else
							DataWidth = ( 100 / HoleCount )
						EndIf
						If( StringMatch( "New", New_or_App ) ) // Opens blank graph if this is a new plot
							Display/W=(576,67,1557,526)
						EndIf
						For( i = 0; i < HoleCount; i += 1 ) // This loop works through the hole list and appends the data
							Hole = StringFromList( i, HoleList )
							Site = RemoveEnding( Hole )
							WAVE/Z DataWave = $"root:" + Site + "_" + Technique + ":" + Hole + "_" + Technique + "_" + Data // Sets wave reference for data wave
							If( WaveExists( DataWave ) )
								Old_Append_Data_F( StringFromList( i, HoleList ), Technique, Data, Xaxis, "B", "Append", DataWidth * i , ( DataWidth * (i + 1) ), "R" ) // Appends the data to the plot
							Else
								Print "\rI can't find " + Hole + "_" + Technique + "_" + Data + " in DataFolder " +  Site + "_" + Technique + "\r\r" // Error message if data wave is missing
							EndIf
						EndFor
						String/G G_New_or_App = New_or_App
						ModifyGraph nticks(bottom)=10,minor(bottom)=1, mirror=2 // Plot formatting
						ShowInfo // Add cursors
					SetDataFolder root:
			Else
				Data_SameAxisPlot_F( HoleList, Technique, Data, Xaxis, New_or_App, SpliceYorN ) // For single axis plots. See below
			EndIf
	End	

//	Function Data_SameAxisPlot_F( HoleList, Technique, Data, Xaxis, New_or_App, SpliceYorN )
			String HoleList, Technique, Data, Xaxis, New_or_App, SpliceYorN
			CheckList4Semicolons( HoleList ) // Checks to make sure that the list of holes is semicolon separated
		SetDataFolder root:
			Variable i, HoleCount, DataWidth
			String Hole, Site
			HoleCount = ItemsInList( HoleList ) // How many data sets?
			If( StringMatch( "New", New_or_App ) ) // Opens blank graph if this is a new plot
				Display/W=(576,67,1557,526)
			EndIf
			For( i = 0; i < HoleCount; i += 1 )
				Hole = StringFromList( i, HoleList )
				Site = RemoveEnding( Hole )
		SetDataFolder $Site + "_" + Technique // Make the data folder the active folder
				WAVE/Z DataWave = $Hole + "_" + Technique + "_" + Data // Set wave reference for the data wave
				If( WaveExists( DataWave ) )
					AppendToGraph/R = $Data $StringFromList( i, HoleList ) + "_" + Technique + "_" + Data  vs $Hole + "_" + Technique + "_" + Xaxis // Appends the data to the plot
				Else
					Print "\rI can't find " + Hole + "_" + Technique + "_" + Data + " in DataFolder " +  Site + "_" + Technique + "\r\r" // Error message if data wave is missing
				EndIf
		SetDataFolder root:
			EndFor
			String/G G_New_or_App = New_or_App
			ModifyGraph nticks(bottom)=10,minor(bottom)=1, mirror=2 // Formatting
			ModifyGraph freePos=0
			Label $Data "\\Z12\\f01" + Data
			ModifyGraph lblPosMode=2,lblMargin=5
			ShowInfo // Add cursors
			If( StringMatch( SpliceYorN, "Y" ) ) // If the user wants room for spliced data the single Y axis for the requested data is set to 0-75%
				ModifyGraph axisEnab($Data)={0,0.75}
			EndIf
		SetDataFolder root:
	End	

