﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.

// This function strips a user specified number of rows of pixels from the top and the bottom of an image. It is intended to get rid of irregular edges of
//  core images that have been cut from core table photos or cropped from old scanner images. It trims all of the images in the designated folder.

	Function Image_Trim( )
		SetDataFolder root:
			PauseUpdate;
			Variable/G G_Pixels2Trim
			Variable Pixels2Trim = G_Pixels2Trim, Width, i
			String FldrList = SortList( FolderList( "*" ) ), Folder // List of folders does not include root: to protect coring matrices which are 3D like images
			Prompt Pixels2Trim, "Number of pixels ( rows ) to trim from top and bottom of each image in the folder:" // Number of rows to delete - both top and bottom
			Prompt Folder, "Image Folder:", popup, FldrList
			DoPrompt "ImageTrim", Folder, Pixels2Trim; AbortOnValue V_Flag, 0
			G_Pixels2Trim = Pixels2Trim
		SetDataFolder $"root:" + Folder
			String WvList = WaveList( "*", ";", "DIMS:3" )	// List of images in the folder ( note "DIMS:3" excludes non 3 layer waves )
			For( i = 0; i < ItemsInList( WvList ); i += 1 )  // This loop processes each image in succession
				WAVE Image = $StringFromList( i, WvList )
				Width = DimSize( Image, 1 ) // Width is the original number of rows in the image
				Redimension/N=(-1, Width - Pixels2Trim, -1) Image // The width is reduced on 1 side by the requested amount
				ImageRotate/V/O Image // The image is rotated about a horizontal axis
				Width = DimSize( Image, 1 ) // The width is reset after trimming one side
				Redimension/N=(-1, Width - Pixels2Trim, -1) Image  // The width is reduced on the opposite side of the image
				ImageRotate/V/O Image	// The image is rotated back into its original orientation
				SetScale/I y 0,1,"", Image // The Y axis scale is reset to 0 to 1
			EndFor
		SetDataFolder root:	
	End
