﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.



	Function Interpolation()
		SetDataFolder root:
			String/G G_Depth , G_Value , G_iDepth 										// Establish the Global strings for the names of the Depth, Value, and iDepth waves
			String iDepth = G_iDepth, Depth = G_Depth, Value = G_Value  // Set the Local strings to be the same as the Global strings
																												// If the Globals do not exist, the locals will be empty strings until you select them in the prompts below
			String/G G_OrigFolder
			String OrigFolder = G_OrigFolder 				// Set the Origin data folder name to the origin folder name selected last time the function was run
			Prompt OrigFolder "Select folder with data to be interpolated" , popup , FolderList ("*")
			DoPrompt "Interpolation", OrigFolder 					// Select folder with the values with XY data
			G_OrigFolder = OrigFolder 										// Reset the Origin Folder global value to the Folder just selected
			AbortOnValue V_Flag , 0 										// Abort the run if "Cancel" was selected in the Prompt above
		
		SetDataFolder $OrigFolder 
			Prompt Depth , "Select X data e.g. depth, age,..." , popup , SortList( WaveList("*" , ";" , "" ) )
			Prompt Value , "Select Y data e.g. isotope values, XRF,..." , popup , SortList( WaveList("*" , ";" , "" ) )
			DoPrompt "Interpolation", Depth, Value // Select the X and Y origin data waves
			G_Depth = Depth ; G_Value = Value			// Reset the Global strings to the strings just selected
			AbortOnValue V_Flag , 0							// Abort the run if "Cancel" was selected in the Prompt above
			Wave DepthRef = $Depth , ValueRef = $Value // Create Wave References for the selected waves.
																					// The "$" tells Igor that the string is the name of a wave
		SetDataFolder root:
			String/G G_iFolder
			String iFolder = G_iFolder
			Prompt iFolder "Select destination folder for interpolated data" , popup , FolderList ("*")
			DoPrompt "Interpolation" , iFolder // Select folder with the values with data to be interpolated
			G_iFolder = iFolder
			AbortOnValue V_Flag , 0
			
		SetDataFolder $iFolder
			Prompt iDepth , "Select X data e.g. depth, age,..." , popup , SortList( WaveList("*" , ";" , "" ) )
			DoPrompt "Interpolation" , iDepth  		// Select the depth or age wave providing the depth/age points to be interpolated from the data waves selected above
			AbortOnValue V_Flag , 0
			G_iDepth = iDepth
			Wave iDepthRef = $iDepth	
					
			String iValueName = FirstPart( iDepth ) +"_"+ SecondPart( iDepth ) + "_i" + ThirdPart( Value ) // Create a string for the name of the wave to contain the interpolated data values
			Duplicate/O iDepthRef, $iValueName // Create a wave with the name of the string above that is the same length as the depth point wave
			Wave iValueRef = $iValueName				// Create the wave reference for the wave that will hold the interpolated values		
			iValueRef = interp( iDepthRef , DepthRef , ValueRef) // Do the interpolation

		SetDataFolder root:
			Display/N = InterpolatdDataPlot /W = (182,45,986,558) iValueRef vs iDepthRef	 // If the plot isn't open, create a new plot named "InterpolatdDataPlot"
			AppendToGraph ValueRef vs DepthRef
			ModifyGraph mode( $iValueName ) = 3, marker( $iValueName ) = 19, rgb( $iValueName ) = ( 0, 0, 0 )
	End