﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.

	Function RSCJANUSDataLoader( )
		SetDataFolder root:
			Variable/G G_CC_Replacement
			Variable CC_Replacement = G_CC_Replacement
			Prompt CC_Replacement, "Replace CC's with column number used in Coring Matrix ( 9 is default )"
			DoPrompt "RSCJANUSDataLoader", CC_Replacement
			G_CC_Replacement = CC_Replacement; AbortOnValue V_Flag, 0
			Print "RSCJANUSDataLoader_F(",CC_Replacement,")"
			RSCJANUSDataLoader_F( CC_Replacement )
	End
	
	Function RSCJANUSDataLoader_F( CC_Replacement )
			Variable CC_Replacement
		SetDataFolder root:
			String SiteNum, Hole
			WAVE/T H, TW
			WAVE Leg,Site,Core,SecW,Top__cm_,Depth__mbsf_,L_,a_,b_,Munsell_HVC,XW,YW,ZW
			If( !WaveExists( L_ ) )
				Print "I can't find the datawave \"L_\".\r\t\tDid you forget to copy the column label line along with the data?\r\t\t\t\tOR\r\t\tAre you sure the data are RSC data from JANUS?"
				ABORT "I can't find the datawave \"L_\".\r\rDid you forget to copy the column label line along with the data?\r\rOR\r\rAre you sure the data are RSC data from JANUS?"
			EndIf
			If( NumType( Core[0] ) == 2 ) // Checks to see if the first line in the DataTable is blank
				DeletePoints 0,1,   Leg,Site,H,Core,TW,SecW,Top__cm_,Depth__mbsf_,L_,a_,b_,Munsell_HVC,XW,YW,ZW
			EndIf
			If( StrSearch( WinList( "*", ";", "WIN:2" ), "JANUSDataTable", 0 ) < 0  || StrSearch( WaveList( "*", ",", "WIN:JANUSDataTable" ), "L_", 0 ) < 0 ) // Checks that the data are in the designated Table named "JANUSDataTable"
				Print "The data are not in a table named \"JANUSDataTable\". \r\t\tKill the data waves you just pasted and Run:\r\t\t\t\tEmptyJANUSDataTable()\r\t\tfrom the JANUS_Loaders menu and then paste the data into the new blank table.\r\t\tAfter the first run the table will open automatically."
				ABORT "The data are not in a table named \"JANUSDataTable\". \r\rKill the data waves you just pasted and Run:\r\r\"EmptyJANUSDataTable\"\r\rfrom the JANUS_Loaders menu and then paste the data into the new blank table.\r\rAfter the first run the table will open automatically."
			EndIf
			Hole = "U" + Num2Str( Site[ 0 ] ) + H[ 0 ]
			SiteNum = "U" + Num2Str( Site[ 0 ] )
			NewDataFolder/O $SiteNum + "_RSC"
			Replace_NaNswithNumber_F( "SECW", CC_Replacement )
			Duplicate/O H, $":" + SiteNum + "_RSC:" + Hole + "_RSC_Hole"; 
			Duplicate/O Core, $":" + SiteNum + "_RSC:" + Hole + "_RSC_Core"; 
			Duplicate/O TW, $":" + SiteNum + "_RSC:" + Hole + "_RSC_Type"; 
			Duplicate/O SecW, $":" + SiteNum + "_RSC:" + Hole + "_RSC_Section"; 
			Duplicate/O Top__cm_, $":" + SiteNum + "_RSC:" + Hole + "_RSC_Interval"; 
			Duplicate/O Depth__mbsf_, $":" + SiteNum + "_RSC:" + Hole + "_RSC_mbsf"; 
			Duplicate/O L_, $":" + SiteNum + "_RSC:" + Hole + "_RSC_LStar"; 
			Duplicate/O a_, $":" + SiteNum + "_RSC:" + Hole + "_RSC_AStar"; 
			Duplicate/O b_, $":" + SiteNum + "_RSC:" + Hole + "_RSC_BStar"; 
			Duplicate/O Munsell_HVC, $":" + SiteNum + "_RSC:" + Hole + "_RSC_MunsellHVC"; 
			Duplicate/O XW, $":" + SiteNum + "_RSC:" + Hole + "_RSC_X"; 
			Duplicate/O YW, $":" + SiteNum + "_RSC:" + Hole + "_RSC_Y"; 
			Duplicate/O ZW, $":" + SiteNum + "_RSC:" + Hole + "_RSC_Z"; 
			Duplicate/O H, $":" + SiteNum + "_RSC:" + Hole + "_RSC_Site"; 
			WAVE/T SiteWv = $":" + SiteNum + "_RSC:" + Hole + "_RSC_Site"
			SiteWv = SiteNum
			EmptyJANUSDataTable( )
			KillWaves H, TW
			KillWaves Leg,Site,Core,SecW,Top__cm_,Depth__mbsf_,L_,a_,b_,Munsell_HVC,XW,YW,ZW
	End
	