﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.


	Function XRFJANUSDataLoader( )
		SetDataFolder root:
			String/G G_YorN
			String YorN = G_YorN
			Variable/G G_CC_Replacement
			Variable CC_Replacement = G_CC_Replacement
			Prompt YorN, "Do you want to discard empty data waves?", popup, "Yes;No"
			Prompt CC_Replacement, "Replace CC's with column number used in Coring Matrix ( 9 is default )"
			DoPrompt "XRFJANUSDataLoader", CC_Replacement, YorN
			G_CC_Replacement = CC_Replacement; G_YorN = YorN; AbortOnValue V_Flag, 0
			Print "XRFJANUSDataLoader_F(", CC_Replacement, ", \"" + YorN + "\" )"
			XRFJANUSDataLoader_F( CC_Replacement, YorN )
	End
	
	Function XRFJANUSDataLoader_F( CC_Replacement, YorN )
			String YorN
			Variable CC_Replacement
		SetDataFolder root:
			String SiteNum, Hole
			WAVE/T H, TW, Run, REP, Sample_Type, Comment
			WAVE Leg,Site,Cor,Sct,Top__cm_,Bot__cm_,Depth__mbsf_,Bead_loi
			WAVE SiO2__wt___,TiO2__wt___,Al2O3__wt___,Fe2O3___wt___,MnO__wt___,MgO__wt___,CaO__wt___,Na2O__wt___,K2O__wt___,P2O5__wt___,Nb__ppm_
			WAVE Zr__ppm_,Y__ppm_,S__ppm_,Sr__ppm_,Rb__ppm_,Sc__ppm_,Mo__ppm_,Be__ppm_,Th__ppm_,Co__ppm_,Gd__ppm_,Dy__ppm_,Er__ppm_,Yb__ppm_,Hf__ppm_
			WAVE Pb__ppm_,Ga__ppm_,Zn__ppm_,Cu__ppm_,Ni__ppm_,Cr__ppm_,V__ppm_,Ce__ppm_,Ba__ppm_,Cs__ppm_,La__ppm_,Nd__ppm_,Sm__ppm_
			If( NumType( Cor[0] ) == 2 ) // Checks to see if the first line in the DataTable is blank
				DeletePoints 0,1, H, TW, Run, REP, Sample_Type, Comment
				DeletePoints 0,1, Leg,Site,Cor,Sct,Top__cm_,Bot__cm_,Depth__mbsf_,Bead_loi
				DeletePoints 0,1, SiO2__wt___,TiO2__wt___,Al2O3__wt___,Fe2O3___wt___,MnO__wt___,MgO__wt___,CaO__wt___,Na2O__wt___,K2O__wt___,P2O5__wt___,Nb__ppm_
				DeletePoints 0,1, Zr__ppm_,Y__ppm_,S__ppm_,Sr__ppm_,Rb__ppm_,Sc__ppm_,Mo__ppm_,Be__ppm_,Th__ppm_,Co__ppm_,Gd__ppm_,Dy__ppm_,Er__ppm_,Yb__ppm_,Hf__ppm_
				DeletePoints 0,1, Pb__ppm_,Ga__ppm_,Zn__ppm_,Cu__ppm_,Ni__ppm_,Cr__ppm_,V__ppm_,Ce__ppm_,Ba__ppm_,Cs__ppm_,La__ppm_,Nd__ppm_,Sm__ppm_
			EndIf
			If( !WaveExists( CaO__wt___ ) )
				Print "I can't find the datawave \"CaO__wt___\".\r\t\tDid you forget to copy the column label line along with the data?\r\t\t\t\tOR\r\t\tAre you sure the data are XRF data from JANUS?"
				ABORT "I can't find the datawave \"CaO__wt___\".\r\rDid you forget to copy the column label line along with the data?\r\rOR\r\rAre you sure the data are XRF data from JANUS?"
			EndIf
			If( StrSearch( WinList( "*", ";", "WIN:2" ), "JANUSDataTable", 0 ) < 0  || StrSearch( WaveList( "*", ",", "WIN:JANUSDataTable" ), "CaO__wt___", 0 ) < 0 ) // Checks that the data are in the designated Table named "JANUSDataTable"
				Print "The data are not in a table named \"JANUSDataTable\". \r\t\tKill the data waves you just pasted and Run:\r\t\t\t\tEmptyJANUSDataTable()\r\t\tfrom the JANUS_Loaders menu and then paste the data into the new blank table.\r\t\tAfter the first run the table will open automatically."
				ABORT "The data are not in a table named \"JANUSDataTable\". \r\rKill the data waves you just pasted and Run:\r\r\"EmptyJANUSDataTable\"\r\rfrom the JANUS_Loaders menu and then paste the data into the new blank table.\r\rAfter the first run the table will open automatically."
			Endif
			Hole = "U" + Num2Str( Site[ 0 ] ) + H[ 0 ]
			SiteNum = "U" + Num2Str( Site[ 0 ] )
			NewDataFolder/O $SiteNum + "_JanusXRF"
			Replace_NaNswithNumber_F( "Sct", CC_Replacement )
			Duplicate/O H, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_Hole"; 
			Duplicate/O Cor, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_Core"; 
			Duplicate/O TW, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_Type"; 
			Duplicate/O Sct, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_Section"; 
			Duplicate/O Top__cm_, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_Interval"; 
			Duplicate/O Depth__mbsf_, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_mbsf"; 
			Duplicate/O SiO2__wt___, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_SiO2"
			Duplicate/O TiO2__wt___, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_TiO2"
			Duplicate/O Al2O3__wt___, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_Al2O3"
			Duplicate/O Fe2O3___wt___, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_Fe2O3"
			Duplicate/O MnO__wt___, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_MnO"
			Duplicate/O MgO__wt___, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_MgO"
			Duplicate/O CaO__wt___, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_CaO"
			Duplicate/O Na2O__wt___, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_Na2O"
			Duplicate/O K2O__wt___, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_K2O"
			Duplicate/O P2O5__wt___, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_P2O5"
			Duplicate/O Nb__ppm_, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_Nb"
			Duplicate/O Zr__ppm_, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_Zr"
			Duplicate/O Y__ppm_, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_Y"
			Duplicate/O S__ppm_, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_S"
			Duplicate/O Sr__ppm_, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_Sr"
			Duplicate/O Rb__ppm_, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_Rb"
			Duplicate/O Sc__ppm_, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_Sc"
			Duplicate/O Mo__ppm_, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_Mo"
			Duplicate/O Be__ppm_, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_Be"
			Duplicate/O Th__ppm_, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_Th"
			Duplicate/O Co__ppm_, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_Co"
			Duplicate/O Gd__ppm_, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_Gd"
			Duplicate/O Dy__ppm_, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_Dy"
			Duplicate/O Er__ppm_, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_Er"
			Duplicate/O Yb__ppm_, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_Yb"
			Duplicate/O Hf__ppm_, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_Hf"
			Duplicate/O Pb__ppm_, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_Pb"
			Duplicate/O Ga__ppm_, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_Ga"
			Duplicate/O Zn__ppm_, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_Zn"
			Duplicate/O Cu__ppm_, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_Cu"
			Duplicate/O Ni__ppm_, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_Ni"
			Duplicate/O Cr__ppm_, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_Cr"
			Duplicate/O V__ppm_, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_V"
			Duplicate/O Ce__ppm_, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_Ce"
			Duplicate/O Ba__ppm_, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_Ba"
			Duplicate/O Cs__ppm_, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_Cs"
			Duplicate/O La__ppm_, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_La"
			Duplicate/O Nd__ppm_, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_Nd"
			Duplicate/O Sm__ppm_, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_Sm"
			Duplicate/O H, $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_Site"; 
			WAVE/T SiteWv = $":" + SiteNum + "_JanusXRF:" + Hole + "_JanusXRF_Site"
			SiteWv = SiteNum
			EmptyJANUSDataTable( )
			KillWaves H, TW, Run, REP, Sample_Type, Comment
			KillWaves Leg,Site,Cor,Sct,Top__cm_,Bot__cm_,Depth__mbsf_,Bead_loi
			KillWaves SiO2__wt___,TiO2__wt___,Al2O3__wt___,Fe2O3___wt___,MnO__wt___,MgO__wt___,CaO__wt___,Na2O__wt___,K2O__wt___,P2O5__wt___,Nb__ppm_
			KillWaves Zr__ppm_,Y__ppm_,S__ppm_,Sr__ppm_,Rb__ppm_,Sc__ppm_,Mo__ppm_,Be__ppm_,Th__ppm_,Co__ppm_,Gd__ppm_,Dy__ppm_,Er__ppm_,Yb__ppm_,Hf__ppm_
			KillWaves Pb__ppm_,Ga__ppm_,Zn__ppm_,Cu__ppm_,Ni__ppm_,Cr__ppm_,V__ppm_,Ce__ppm_,Ba__ppm_,Cs__ppm_,La__ppm_,Nd__ppm_,Sm__ppm_
			If( StringMatch( YorN, "Yes" ) )
				SetDataFolder  $":" + SiteNum + "_JanusXRF"
					KillEmptyWaves( )
				SetDataFolder root:
			Endif
	End
			