﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.


	Function PWSNGDCDataLoader( )
		SetDataFolder root:
			Variable/G G_CC_Replacement
			Variable CC_Replacement = G_CC_Replacement
			Prompt CC_Replacement, "Replace CC's with column number used in Coring Matrix ( 9 is default )"
			DoPrompt "PWSNGDCDataLoader", CC_Replacement
			G_CC_Replacement = CC_Replacement; AbortOnValue V_Flag, 0
			Print "PWSNGDCDataLoader_F(",CC_Replacement,")"
			PWSNGDCDataLoader_F( CC_Replacement )
	End
	
	Function PWSNGDCDataLoader_F( CC_Replacement )
			Variable CC_Replacement
		SetDataFolder root:
			Variable/G G_HoleVorS
			String SiteNum, H
			EXECUTE "G_HoleVorS = WaveType( Hole )" // This necessary for DSDP data as the first Hole was "blank" and the second Hole is "A".
			If( G_HoleVorS == 2 || G_HoleVorS == 4 )									// The Hole wave is read as a numerical wave and must be replaced with a text wave with value "X"
				DoWindow/F NGDCDataTable
				EXECUTE "RemoveFromTable Hole"
				EXECUTE "KillWaves Hole "
				EXECUTE "Make/T/N = ( NumPnts( Site ) ) Hole"
				EXECUTE "Hole = \"X\""
				EXECUTE "AppendToTable Hole"
			Endif
			WAVE/T orientation, Hole
  			WAVE leg,site,core,section,top_interval_depth__cm_,bottom_interval_depth__cm_
  			WAVE top_of_core_depth__m_,sample_depth__m_,sonic_velocity__km_sec_temperat,split_core,instrument_code
  			If( !WaveExists( sonic_velocity__km_sec_temperat ) )
				Print "I can't find the datawave \"sonic_velocity__km_sec_temperat\".\r\t\tDid you forget to copy the column label line along with the data?\r\t\t\t\tOR\r\t\tAre you sure the data are PWS data from NGDC?"
				ABORT "I can't find the datawave \"sonic_velocity__km_sec_temperat\".\r\rDid you forget to copy the column label line along with the data?\r\rOR\r\rAre you sure the data are PWS data from NGDC?"
			EndIf
			If( NumType( Core[0] ) == 2 ) // Checks to see if the first line in the DataTable is blank
				DeletePoints 0,1, orientation, Hole
  				DeletePoints 0,1, leg,site,hole,core,section,top_interval_depth__cm_,bottom_interval_depth__cm_
  				DeletePoints 0,1, top_of_core_depth__m_,sample_depth__m_,sonic_velocity__km_sec_temperat,split_core,instrument_code
			EndIf
			If( StrSearch( WinList( "*", ";", "WIN:2" ), "NGDCDataTable", 0 ) < 0  || StrSearch( WaveList( "*", ",", "WIN:NGDCDataTable" ), "sonic_velocity__km_sec_temperat", 0 ) < 0 ) // Checks that the data are in the designated Table named "NGDCDataTable"
				Print "The data are not in a table named \"NGDCDataTable\". \r\t\tKill the data waves you just pasted and Run:\r\t\t\t\tEmptyNGDCDataTable()\r\t\tfrom the NGDC_Loaders menu and then paste the data into the new blank table.\r\t\tAfter the first run the table will open automatically."
				ABORT "The data are not in a table named \"NGDCDataTable\". \r\rKill the data waves you just pasted and Run:\r\r\"EmptyNGDCDataTable\"\r\rfrom the NGDC_Loaders menu and then paste the data into the new blank table.\r\rAfter the first run the table will open automatically."
			Endif
			H = "U" + Num2Str( Site[ 0 ] ) + Hole[ 0 ]
			SiteNum = "U" + Num2Str( Site[ 0 ] )
			NewDataFolder/O $SiteNum + "_PWS"
			Replace_NaNswithNumber_F( "Section", CC_Replacement )
			Duplicate/O Site, $":" + SiteNum + "_PWS:" + H + "_PWS_Site"; 
			Duplicate/O Hole, $":" + SiteNum + "_PWS:" + H + "_PWS_Hole"; 
			Duplicate/O Core, $":" + SiteNum + "_PWS:" + H + "_PWS_Core"; 
			Duplicate/O Section, $":" + SiteNum + "_PWS:" + H + "_PWS_Section"; 
			Duplicate/O top_interval_depth__cm_, $":" + SiteNum + "_PWS:" + H + "_PWS_Interval"; 
			Duplicate/O sample_depth__m_, $":" + SiteNum + "_PWS:" + H + "_PWS_mbsf"; 
			Duplicate/O sonic_velocity__km_sec_temperat, $":" + SiteNum + "_PWS:" + H + "_PWS_Vp"; 
			EmptyNGDCDataTable( )
			KillWaves	orientation, Hole
  			KillWaves leg,site,core,section,top_interval_depth__cm_,bottom_interval_depth__cm_
  			KillWaves top_of_core_depth__m_,sample_depth__m_,sonic_velocity__km_sec_temperat,split_core,instrument_code

	End
			