﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3		// Use modern global access method and strict wave access.

// This function returns the position in a string of an underscore. Instance is 1 for the first underscore, 2 for the second, etc

	Function FindUnderscore( NameString, Instance ) 
		String NameString // NameString is the string to be searched
		Variable Instance // The Nth time an underscore occurs in the string ( e.g. 1, 2, 3, ... )
		If( Instance == 0 ) // Check to see that Instance isn't 0
			ABORT "FindUnderscore( String, Instance )\rneeds an Instance > 0. Use 1 for the first occurance of an underscore, 2 for the second, etc."
		EndIf
		Variable i, j, k, l
		For( i = 0; i < Instance; i += 1 )
			j = StrSearch( NameString, "_", j + 1 ) //  look for an underscore starting with the character after the last underscore position
			If( j < 0 ) //  If there is no Nth underscore, stop
				ABORT "There aren't " + Num2Str( Instance ) + " underscores in " + NameString
				Break
			Else
				k += 1
			EndIf
			l = j
		EndFor
		Return l
	End
