#pragma rtGlobals=3		// Use modern global access method and strict wave access.

	Function Set_Data_Range( )
		SetDataFolder root:
			String/G G_Data, G_AllGraphs
			String Data = G_Data, AllGraphs = G_AllGraphs
			Variable/G G_Top, G_Bottom
			Variable Top = G_Top, Bottom = G_Bottom
			Variable i 
			Prompt Data,"Data Type ( e.g. GRA, Fe_Area, AStar )"
			Prompt Bottom, "Lower"
			Prompt Top, "Upper"
			Prompt AllGraphs, "Only the Top Graph or All Graphs?", popup, "TopGraph;All"
			DoPrompt "Set_Data_Range", Data, Bottom, Top, AllGraphs; 
			G_Data = Data; G_Top = Top; G_Bottom = Bottom; G_AllGraphs = AllGraphs; AbortOnValue V_Flag, 0
			Set_Data_Range_F( Data, Bottom, Top, AllGraphs )
			Print "Set_Data_Range_F( \"" + Data + "\"," + Num2Str( Bottom ) + ", " + Num2Str( Top ) + ", \"" + AllGraphs + "\" )"
	End

---------------------------------------------------------------------

	Function Set_Data_Range_F( Data, Bottom, Top, AllGraphs )
		String Data, AllGraphs
		Variable Top, Bottom
		SetDataFolder root:
			String AxList, Axis, GraphList, GraphName
			Variable i, j
			If( StringMatch( "TopGraph", AllGraphs ) ) // This is the case of only the TOP graph 
				AxList = AxisList( "" ) // Create a list of axes on the graph
				For( i = 0; i < ItemsInList( AxList ); i += 1 ) // Loop through the list of axes
					Axis = StringfromList( i, AxList, ";" ) // Select an axis from the axis list
					If( StrSearch( Axis, Data, 0, 2 ) >= 0  ) // Check to see if the axis name includes the user input data type
						SetAxis $Axis Bottom, Top // If the axis name includes the data type, reset the data range of that axis
					EndIf
				EndFor
			Else // This is the case of ALL graphs being adjusted
				GraphList = WinList( "*", ";", "WIN:1" ) // Make a list of all graphs
				For( j = 0; j < ItemsInList( GraphList ); j += 1 ) // Loop through every graph
					GraphName = StringFromList( j, GraphList ) // Select a graph from the list of graphs
					AxList = AxisList( GraphName )  // Create a list of axes on the selected graph
					For( i = 0; i < ItemsInList( AxList ); i += 1 ) // Loop through the list of axes
						Axis = StringfromList( i, AxList, ";" ) // Select an axis from the axis list
						If( StrSearch( Axis, Data, 0, 2 ) >= 0  ) // Check to see if the axis name includes the user input data type
							SetAxis/Z/W = $GraphName $Axis Bottom, Top // If the axis name includes the data type, reset the data range of that axis
						EndIf
					EndFor
				EndFor
			EndIf
	EndMacro

