#pragma rtGlobals=1		// Use modern global access method.

// Last change 19JUN2017 to correct Image_Extension  to include the "." and 3 characters, like ".jpg". Also dropped Type from K_ folder names.

*********************************************************************
	
	Function Universal_Image_Loader( )
		SetDataFolder root:
			Variable/G G_Core_Num, G_Type_Location, G_V1, G_CCNumber, G_X_Resolution
			String/G G_Hole, G_CoreNumber, G_Core_Number_Location, G_Section_Number_Location, G_Image_Extension
			String Core = G_CoreNumber, Hole = G_Hole
			String Core_Number_Location = G_Core_Number_Location, Section_Number_Location = G_Section_Number_Location, Image_Extension = G_Image_Extension
			Variable X_Resolution = G_X_Resolution, Type_location = G_Type_Location, CCNumber = G_CCNumber
			Prompt Core_Number_Location, "Core Number Location"
			Prompt Section_Number_Location, "Section Number Location"
			Prompt Type_Location, "Type Location"
			Prompt Image_Extension, "Image Extension ( 4 characters including \".\" e.g. \".jpg\" )"
			Prompt Hole, "Hole"
			Prompt Core,  "Core"
			Prompt X_Resolution, "X ( depth ) Resolution (m) "
			Prompt CCNumber, "Section Number to use in place of CC"
			DoPrompt "Universal_Image_Loader", Core_Number_Location, Section_Number_Location, Type_Location, Image_Extension, Hole, Core,  X_Resolution, CCNumber; AbortonValue V_Flag, 0
			Hole = UpperStr( Hole ) // Sets Hole letter to uppercase for formation of folders and wave names
			G_CoreNumber = Core; G_Hole = Hole
			G_Core_Number_Location = Core_Number_Location; G_Section_Number_Location = Section_Number_Location; G_Image_Extension = Image_Extension
			G_X_Resolution = X_Resolution; G_Type_location = Type_Location; G_CCNumber = CCNumber
			AbortOnValue V_Flag, 0
			Universal_Image_Loader_F( Core_Number_Location, Section_Number_Location, Type_Location, Image_Extension, Hole,Core, X_Resolution, CCNumber )
			Print "Universal_Image_Loader_F( \"" +  Core_Number_Location + "\", \"" + Section_Number_Location + "\", " + Num2Str( Type_Location ) +", \"" + Image_Extension + "\", \"" + Hole + "\", \"" + Core + "\", " + Num2Str( X_Resolution ) + ", " + Num2Str( CCNumber ) + " )"
	End
	
	***************************************************************
	
	Function Universal_Image_Loader_F( Core_Number_Location, Section_Number_Location, Type_Location, Image_Extension, Hole, Core, X_Resolution, CCNumber )
		String Core, Hole
		String Core_Number_Location, Section_Number_Location, Image_Extension
		Variable X_Resolution, Type_location, CCNumber
		Variable i = 0, j = 0, V_Core, V_Section, Section_Top, Section_Bottom, V1, V2,  X_Pnts
		String S1, Section, DF, Type
		String/G G_Hole
		Hole = UpperStr( Hole ); G_Hole = Hole // Sets Hole letter to uppercase for formation of folders and wave names
		SetDataFolder root:
			PathInfo Image_Path
			If( !V_Flag )
				DoAlert 0, "You forgot to establish the path to the folder holding the images.\r\r Click O.K. and select the folder.\r\r Remember to change the path for different holes."
				NewPath Image_Path
				AbortOnValue V_Flag, 0
			EndIf
			If( !Exists( Hole+"_Coring_Matrix" ) )
				Print "The Coring Matrix for " + Hole + " is missing from the root directory.\r\rReload the matrix and try again."
				Abort "The Coring Matrix for " + Hole + " is missing from the root directory.\r\rReload the matrix and try again."
			EndIf	
			WAVE Matrix = $Hole + "_Coring_Matrix"
			String No_U_Hole = Hole[ 1, inf ]
			Variable  CN1, CN2, SN1, SN2
			If( StrLen ( Core_Number_Location ) > 1 )		// makes the string variable(s) for location into numeric variable(s)
				CN1 = Str2Num( StringFromList( 0, Core_Number_Location ) )
				CN2 = Str2Num( StringFromList( 1, Core_Number_Location, "," ) )
			Else
				CN1 = Str2Num( Core_Number_Location )
			EndIf
	
			If( Str2Num( Core ) >= 10 && StrLen( Core_Number_Location ) == 1 )
				DoAlert 1, "The function is trying to load core number " + Core + " but the field for core number location indicates a single character.\r\rDo you want to contine?"
				AbortOnValue V_Flag == 2, 0
			EndIf	
	
			If( StrLen ( Section_Number_Location ) > 1 )		// makes the string variable(s) for location into numeric variable(s)
				SN1 = Str2Num( StringFromList( 0, Section_Number_Location ) )
				SN2 = Str2Num( StringFromList( 1, Section_Number_Location, "," ) )
			Else
				SN1 = Str2Num( Section_Number_Location )
			EndIf
			Variable k = 0
			For( k = 0; k < 10; k += 1 )
					S1 = IndexedFile( Image_Path, k, Image_Extension )
					If( StrLen( S1 ) < 1 )
						Break
					EndIf
					If( StrSearch( S1, Hole, 0, 2 ) < -.05 && StrSearch( S1, No_U_Hole, 0, 2 ) < -.05 )
						PathInfo Image_Path
						Print "I found images that were not for " + Hole + " in folder " + S_Path + ".\r\tDid you forget to change Image_Path from one hole to the next?"
						DoAlert 1, "I found images that were not for " + Hole + " in folder " + S_Path + ".\r\rDid you forget to change Image_Path from one hole to the next?\r\rSelect \"Yes\" to reset the path to the image folder, \"No\" to quit."
						If( V_Flag == 1 )
							NewPath/O Image_Path
							AbortOnValue V_Flag, 0
						Else
							ABORT
						EndIf
					EndIf
			EndFor
	
		// Selecting the proper section images depends on the "Type" designator being in the correct spot. This allows the discrimination
		// between U1336A-3H-2-A_SHLF760941 and U1336A-31X-1-A_SHLF775711 when seeking core 3 (since "3" is in the same place
		// in both file names.
		
			If( Str2Num( Core ) < 10 )		// Creates a new datafolder for the section images and makes it the active folder
				DF = "K_"+Hole+"_0" + Core// + Type
			Else
				DF = "K_"+Hole+"_" + Core// + Type
			EndIf
			String ImageList = IndexedFile( Image_Path, -1, Image_Extension ) // Creates a list of all of the images in the IMAGE_PATH external folder
		NewDataFolder/O/S $DF
			For( i = 0; i < ItemsInList( ImageList ); i += 1 )  // This loop actually loads the images into the new "K_" datafolder
				S1 = StringFromList( i, ImageList )
				Type = S1[ Type_Location ]

		// 	This next "If" skips an image if the Type is not recognized. 
		//		In practice, it is used to check whether a file is >= or < 10. The Type will not be recognized if the position in the file name is incorrect.
				If( !StringMatch( Type, "H" ) && !StringMatch( Type, "F" ) && !StringMatch( Type, "X" ) && !StringMatch( Type, "R" ) )
					Continue
				EndIf			
				If( ItemsInList( Core_Number_Location, "," ) == 1 )
					V_Core = Str2Num( S1[ CN1 ] )		// For cores # 1 - 9
				Else
					V_Core = Str2Num( S1[ CN1, CN2 ] )		// For cores # >= 10
				EndIf
				If( Stringmatch( S1, "*" + "CC" + "*" ) )		// Assigns CC's section number designated in input dialog
						V_Section = CCNumber
				Else	
					If( ItemsInList( Section_Number_Location, "," ) == 1 )
						V_Section = Str2Num( S1[ SN1 ] )		
					Else
						V_Section = Str2Num( S1[ SN1, SN2 ] )	
					EndIf			
				EndIf
				If( Str2Num( Core ) == V_Core )
					If( V_Core < 10 )
						Section = "K_" + Hole + "_0" + Core + Type + "_" + Num2Str( V_Section )
					Else
						Section = "K_" + Hole + "_" + Core + Type + "_" + Num2Str( V_Section )
					EndIf
					ImageLoad/Q/O/P = Image_Path /T = jpeg StringFromList( i, ImageList );
					WAVE ImageWv = $S_FileName
					S_filename = S_filename[ 0, 30 ]
					ReName ImageWv, $S_FileName
					ImageRotate/O /A = 270 ImageWv
					print  Section					
					Section_Top = Matrix[ V_Core ][ V_Section ][ 0 ]
					Section_Bottom = Matrix[ V_Core ][ V_Section ][ 0 ] + Matrix[ V_Core ][ V_Section ][ 1 ]
					X_Pnts = Matrix[ V_Core ][ V_Section ][ 1 ] / X_Resolution		
					ImageInterpolate/DEST = $Section /RESL = { X_Pnts, 201 }  bilinear, ImageWv
					Redimension/B/U $Section
					SetScale x Section_Top, Section_Bottom, "", $Section
					SetScale/I y 0, 1, "", $Section, ImageWv
					Killwaves/Z $S_FileName
				EndIf
			EndFor
			If( !Strlen( WaveList( "*", ";", "" ) ) )
				SetDataFolder root:
				KillDataFolder $DF
				Print "There were no images found for " + Hole + "-" + Core
				Abort "There were no images found for " + Hole + "-" + Core
			EndIf
		SetDataFolder root:
	EndMacro

*********************************************************************
	
